CREATE TABLE [Line]
(
	ID bigint identity(1,1) not null,
	Name varchar(50) not null,
	Type varchar(20) not null,
	Status bit not null,
	CONSTRAINT PK_Line_ID PRIMARY KEY (ID)
)

go

CREATE TABLE [ProductInfo]
(
	ID bigint identity(1,1) not null,
	PartNumber varchar(50) not null,
	PartNumberSAP varchar(50) null,
	LineID bigint not null,
	CycleTime float not null,
	Setup varchar(100) null,
	PrevLineID bigint null,
	NextLineID bigint null,
	ExtraInfoID bigint null,
	CONSTRAINT PK_ProductInfo_ID PRIMARY KEY (ID),
	CONSTRAINT FK_ProductInfo_LineId_Line_ID FOREIGN KEY (LineID) REFERENCES Line (ID),
	CONSTRAINT FK_ProductInfo_PrevLineId_Line_ID FOREIGN KEY (PrevLineID) REFERENCES Line (ID),
	CONSTRAINT FK_ProductInfo_NextLineId_Line_ID FOREIGN KEY (NextLineID) REFERENCES Line (ID)
)

go

CREATE TABLE [Status]
(
	ID int identity(1,1)not null,
	Text varchar(100) null,
	Inputer varchar(50) not null,
	Comment varchar(255) null,
	Note varchar(100) null,
	Color varchar(20) null,
	CONSTRAINT PK_Status_ID PRIMARY KEY (ID)
)

go

CREATE Table [User]
(
	ID bigint identity(1,1) not null,
	[Login] varchar(50) not null,
	FirstName varchar(50) not null,
	LastName varchar (50) not null,
	[Permissions] varchar(30) not null,
	CONSTRAINT PK_User_ID PRIMARY KEY (ID)
)

go

CREATE TABLE [Plan]
(
	ID bigint identity(1,1) not null,
	ProductID bigint not null,
	QtyPlanned bigint not null,
	QtyDone bigint not null,
	StatusID int not null,
	CommentPlanner text null,
	CommentProduction text null,
	[Order] int not null,
	PlanBegin Datetime null,
	PlanEnd Datetime null,
	CONSTRAINT PK_Plan_ID PRIMARY KEY (ID),
	CONSTRAINT FK_Plan_ProductId_ProcutInfo_ID FOREIGN KEY (ProductID) REFERENCES ProductInfo (ID),
	CONSTRAINT FK_Plan_StatusID_Status_ID FOREIGN KEY (StatusID) REFERENCES [Status] (ID)
)