﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.Serialization.Formatters.Binary;
using System.Web;
using ePlanner.JobShop;

namespace ePlanner
{
    static class Extensions
    {
        public static IList<T> Clone<T>(this IList<T> listToClone) where T : ICloneable
        {
            return listToClone.Select(item => (T)item.Clone()).ToList();
        }

        public static List<Operation> DeepClone(List<Operation> obj)
        {
            List<Operation> objResult = null;
            using (MemoryStream ms = new MemoryStream())
            {
                BinaryFormatter bf = new BinaryFormatter();
                bf.Serialize(ms, obj);

                ms.Position = 0;
                objResult = (List<Operation>)bf.Deserialize(ms);
            }
            return objResult;
        }

        public static Graph DeepClone(Graph obj)
        {
            Graph objResult = null;
            using (MemoryStream ms = new MemoryStream())
            {
                BinaryFormatter bf = new BinaryFormatter();
                bf.Serialize(ms, obj);

                ms.Position = 0;
                objResult = (Graph)bf.Deserialize(ms);
            }
            return objResult;
        }

    }
}