﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;

namespace ePlanner
{
    public class Plan
    {
        public long ID { get; set; }

        public long ProductID { get; set; }

        public long QtyPlanned { get; set; }

        public long QtyDone { get; set; }

        public int StatusID { get; set; }

        public string CommentPlanner { get; set; }

        public string CommentProduction { get; set; }

        public int Order { get; set; }

        public DateTime PlanBegin { get; set; }

        public DateTime PlanEnd { get; set; }

        public float ProdStart { get; set; }

        public float ProdEnd { get; set; }
        
        public ProductInfo RelatedProduct { get; set; }

        
        public Plan ()
        {

        }

        public Plan(string pID)
        {
            try
            {
                ID = Convert.ToInt32(pID);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            if (ID > 0)
            {
                DataTable dt = Utility.GetItems(Constants.TableName.Plan, "ID", pID);
                foreach (DataRow dr in dt.Rows)
                {
                    ProductID = Convert.ToInt32(dr["ProductID"]);
                    QtyPlanned = Convert.ToInt32(dr["QtyPlanned"]);
                    QtyDone = Convert.ToInt32(dr["QtyDone"]);
                    StatusID = Convert.ToInt32(dr["StatusID"]);
                    CommentPlanner = Convert.ToString(dr["CommentPlanner"]);
                    CommentProduction = Convert.ToString(dr["CommentProduction"]);
                    Order = Convert.ToInt32(dr["Order"]);

                    if (dr["PlanBegin"] != DBNull.Value)
                    {
                        PlanBegin = Convert.ToDateTime(dr["PlanBegin"]);
                    }
                    if (dr["PlanEnd"] != DBNull.Value)
                    {
                        PlanEnd = Convert.ToDateTime(dr["PlanEnd"]);
                    }

                    if (dr["ProdStart"] != DBNull.Value)
                    {
                        ProdStart = Convert.ToSingle(dr["ProdStart"]);
                    }
                    if (dr["ProdEnd"] != DBNull.Value)
                    {
                        ProdEnd = Convert.ToSingle(dr["ProdEnd"]);
                    }

                    RelatedProduct = new ProductInfo(Convert.ToString(dr["ProductID"]));
                }
            }
        }
        public override string ToString()
        {
            string s = "";

           // s += this.RelatedProduct.PartNumber + " - " + this.RelatedProduct.CycleTime + " ("+this.RelatedProduct.LineID+")";
            s += this.RelatedProduct.PartNumber;
            return s;
        }

    }
}