﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;

namespace ePlanner
{
    public class ProductInfo
    {
        public long ID { get; set; }

        public string PartNumber { get; set; }

        public string PartNumberSAP { get; set; }

        public int LineID { get; set; }

        public float CycleTime { get; set; }

        public string Setup { get; set; }

        public int PrevLineID { get; set; }

        public int NextLineID { get; set; }

        public long ExtraInfoID { get; set; }
        public List<ProductInfo> RelatedProducts { get; set; }
        public Line Line { get; set; }

        public ProductInfo(int LineID)
        {
            this.Line = new Line(Convert.ToString(LineID));
        }

        public ProductInfo()
        {

        }

        public ProductInfo(long pID, string pPartNumber, string pPartNumberSAP, int pLineID, float pCycleTime, string pSetup, int pPrevLineID, int pNextLineID, long pExtraInfoID)
        {
            ID = pID;
            PartNumber = pPartNumber;
            PartNumberSAP = pPartNumberSAP;
            LineID = pLineID;
            CycleTime = pCycleTime;
            Setup = pSetup;
            PrevLineID = pPrevLineID;
            NextLineID = pNextLineID;
            ExtraInfoID = pExtraInfoID;
        }

        public ProductInfo(string pID)
        {
            try
            {
                ID = Convert.ToInt32(pID);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            DataTable dt = Utility.GetItems(Constants.TableName.ProductInfo, "ID", pID);
            foreach (DataRow dr in dt.Rows)
            {
                PartNumber = Convert.ToString(dr["PartNumber"]);
                PartNumberSAP = Convert.ToString(dr["PartNumberSAP"]);
                LineID = Convert.ToInt32(dr["LineID"]);
                CycleTime = Convert.ToSingle(dr["CycleTime"]);
                Setup = Convert.ToString(dr["Setup"]);
                PrevLineID = dr["PrevLineID"] == DBNull.Value ? 0 : Convert.ToInt32(dr["PrevLineID"]);
                NextLineID = dr["NextLineID"] == DBNull.Value ? 0 : Convert.ToInt32(dr["NextLineID"]);
                ExtraInfoID = dr["ExtraInfoID"] == DBNull.Value ? 0 : Convert.ToInt32(dr["ExtraInfoID"]);
            }
        }

       
    }
}