﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Globalization;
using System.Linq;
using System.Web;

namespace ePlanner
{
    public class Shift
    {
        public long ID { get; set; }

        public DateTime ShiftDate { get; set; }
        public string ShiftDateString { get; set; }
        public string ShiftDateYMD { get; set; }
        public DateTime ShiftDateTime { get; set;}

        public int ShiftNo { get; set; }

        public Shift(long parID)
        {
            string sqlQuery = @"
                SELECT ShiftDate, ShiftNo
                FROM
                    Shift
                WHERE ID=@shiftID";

            DataTable dataTable = Utility.GetItemsWithQuery(sqlQuery, new SqlParameter[] { new SqlParameter("shiftID", parID) });
            if (dataTable.Rows.Count == 1)
            {
                DataRow dr = dataTable.Rows[0];
                this.ShiftDate = Convert.ToDateTime(dr["ShiftDate"]);
                this.ShiftDateString = ShiftDate.ToShortDateString();
                this.ShiftDateYMD = ShiftDate.ToString("yyyy/MM/dd", CultureInfo.InvariantCulture);
                this.ShiftNo = Convert.ToInt32(dr["ShiftNo"]);
                this.ID = parID;

                switch(ShiftNo)
                {
                    case 1:
                        this.ShiftDateTime = this.ShiftDate;
                        break;
                    case 2:
                        this.ShiftDateTime = this.ShiftDate.AddHours(8);
                        break;
                    case 3:
                        this.ShiftDateTime = this.ShiftDate.AddHours(16);
                        break;
                    default:
                        this.ShiftDateTime = this.ShiftDate;
                        break;
                }
            }
        }

    }

}