﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ePlanner.JobShop
{
    [Serializable()]
    public class Job
    {
        public List<Operation> operations;

        public Job()
        {
            this.operations = new List<Operation>();
        }

        public Operation GetFirstOperation()
        {
            if (this.operations.Count > 0)
            {
                return this.operations[0];
            }
            return null;
        }

        public Operation GetLastOperation()
        {
            if (this.operations.Count > 0)
            {
                return this.operations[this.operations.Count-1];
            }
            return null;
        }

        public void AddOperation(Operation op)
        {
            if (this.operations.Count > 0)
            {
                this.operations[this.operations.Count - 1].Succ.Add(op);

                op.Pred.Add(this.operations[this.operations.Count - 1]);
            }

            this.operations.Add(op);

        }
    }
}
