﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ePlanner.JobShop
{
    [Serializable()]
    public class Machine
    {
        public long ID;
        public string Name;
        public List<Operation> operations;

        public Machine(long id, string name)
        {
            this.operations = new List<Operation>();
            this.Name = name;
            this.ID = id;
        }

        public Machine(string name)
        {
            this.operations = new List<Operation>();
            this.Name = name;
        }

        public void AddOperation(Operation op)
        {
            this.operations.Add(op);
        }

        public void ShuffleOperation()
        {
            Random rng = new Random();

            int n = this.operations.Count;
            while (n > 1)
            {
                n--;
                int k = rng.Next(n + 1);
                Operation value = this.operations[k];
                this.operations[k] = this.operations[n];
                this.operations[n] = value;
            }
        }

        public override string ToString()
        {
            if (!string.IsNullOrEmpty(this.Name))
                return string.Format("{0}",this.Name);
            return "";
        }

        
    
    }
}
