﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Script.Serialization;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace ePlanner.Menu_items.Product
{
    public partial class Products : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
           // bool hasRows = Utility.AttachDataSource(gvProducts, Constants.TableName.ProductInfo);

        }

        [WebMethod]
        public static string GetProducts()
        {
            string sqlQuery = @"
                SELECT *
                FROM
                    ProductInfo
                ORDER BY PartNumber, LineID";

            DataTable dataTable = Utility.GetItemsWithQuery(sqlQuery);

            List<Job> jobs = new List<Job>();
            List<string> productsNumbers = new List<string>();
            foreach (DataRow row in dataTable.Rows)
            {
                ProductInfo product = new ProductInfo(Convert.ToInt16(row["LineID"]))
                {
                    ID = long.Parse(Convert.ToString(row["ID"])),
                    PartNumber = Convert.ToString(row["PartNumber"]),
                    PartNumberSAP = Convert.ToString(row["PartNumberSAP"]),
                    Setup = Convert.ToString(row["Setup"]),
                    CycleTime = float.Parse(Convert.ToString(row["CycleTime"])),
                    LineID = Convert.ToInt16(row["LineID"])
                };
                
                if (!productsNumbers.Contains(product.PartNumber))
                {
                    Job job = new Job()
                    {
                        PartNumber = product.PartNumber,
                        PartNumberSAP = product.PartNumberSAP,
                        RelatedProducts = new List<ProductInfo>(){product},
                        NoSubProducts = 1
                    };
                    jobs.Add(job);
                    productsNumbers.Add(product.PartNumber);
                }
                else
                {
                    jobs[jobs.Count - 1].NoSubProducts++;
                    jobs[jobs.Count - 1].RelatedProducts.Add(product);
                }
            }
            string myJsonString = (new JavaScriptSerializer()).Serialize(jobs);
            return myJsonString;
        }

        [WebMethod]
        public static string GetLines()
        {
            string sqlQuery = @"
                SELECT *
                FROM
                    Line
                ORDER BY ID";

            DataTable dataTable = Utility.GetItemsWithQuery(sqlQuery);

            List<Line> lines = new List<Line>();
            foreach (DataRow row in dataTable.Rows)
            {
                Line line = new Line()
                {
                    ID = long.Parse(Convert.ToString(row["ID"])),
                    Name = Convert.ToString(row["Name"]),
                    Type = Convert.ToString(row["Type"]),
                    Status = Convert.ToBoolean(row["Status"])
                };
                lines.Add(line);

            }
            string myJsonString = (new JavaScriptSerializer()).Serialize(lines);
            return myJsonString;
        }
    }
}