﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Reflection;
using System.Web;
using System.Web.Script.Serialization;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;
using ePlanner.BCO;
using ePlanner.JobShop;

namespace ePlanner.Menu_items
{
    public partial class PlanPage : System.Web.UI.Page
    {

        public long shiftID;
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                if (Request.QueryString["ShiftID"] != null)
                {
                    shiftID = Convert.ToInt64(Request.QueryString["ShiftID"]);
                    hidShiftID.Value = Convert.ToString(shiftID);

                    lblInfo.Text = "Loading plan...";
                    CreateJobShop(shiftID);
                    lblInfo.Text = "Plan loaded!";
                }
                else
                {
                    // CreateJobShop(10080);
                   // CreateJobShop(10116);
                    CreateJobShop(10133);
                    hidShiftID.Value = Convert.ToString(10133);
                }
               // LoadPlan();
                /*
                if (Request.QueryString["ReloadPlan"] != null)
                {
                   bool reload = Convert.ToBoolean(Request.QueryString["ReloadPlan"]);
                   if (reload)
                   {
                       LoadPlan();
                   }
                }
                */
            }
        }

        private void CreateJobShop(long shiftID)
        {
            Dictionary<long, List<ePlanner.Plan>> storage = new Dictionary<long, List<ePlanner.Plan>>(Utility.GetProductsForShift(shiftID));
            List<Line> lines = new List<Line>(Utility.GetLinesForShift(shiftID));

            Graph graph = new Graph();
            List<JobShop.Job> jobs = new List<JobShop.Job>();
            List<Machine> machines = new List<Machine>();
            foreach(Line line in lines)
            {
                Machine mach = new Machine(line.ID, line.Name);
                machines.Add(mach);
                graph.machines.Add(mach);

                foreach(Plan plannedProduct in storage[line.ID])
                {
                    float cost = Convert.ToInt32(plannedProduct.RelatedProduct.CycleTime);
                    Operation op = new Operation(plannedProduct.ID, plannedProduct.RelatedProduct.PartNumber, mach,cost);
                    op.PlanID = Convert.ToInt32(plannedProduct.ID);
                    op.Setup = plannedProduct.RelatedProduct.Setup;
                    op.CommentProduction = plannedProduct.CommentProduction;
                    op.QtyPlanned = plannedProduct.QtyPlanned;
                    op.QtyDone = plannedProduct.QtyDone;
                    //Job job = GraphStatic.GetJobForOperation(op.Name, jobs);
                    JobShop.Job job = op.GetJobForOperation(jobs);
                    job.AddOperation(op);
                    if (job.operations.Count == 1)
                    {
                        jobs.Add(job);
                    }
                    
                }
            }
            foreach (JobShop.Job job in jobs)
            {
                graph.AddJob(job);
            }

            Graph basicGraph = new Graph();
            basicGraph = Extensions.DeepClone(graph);

            graph.machines.ForEach(m => graph.AddDisjunctiveEdges(m));
            
            //graph.ComputeCPM(ref graph.operations);
            graph.ComputeCPM();

            graph.WriteGraph();
            graph.WriteCriticalPath();
            foreach (Machine mach in graph.machines)
            {
                graph.WriteMachineOperations(mach);
            
            }

            Session["BasicGraph"] = basicGraph;
            Session["ComputedGraph"] = graph;
           // hidBasicGraph.Value = (new JavaScriptSerializer()).Serialize(basicGraph);
          //  hidComputedGraph.Value = (new JavaScriptSerializer()).Serialize(graph);
            DisplayPlan(graph);
            
            //Graph optimizedGraph = OptimizePlan(graph, emptyGraph);
          //  DisplayPlan(optimizedGraph);
          //  UpdatePlanInDB(optimizedGraph);
            

        }

        public void DisplayPlan(Graph graph)
        {
       // VYKRESLENI
            int magicHeightConstant = 5;
            Panel divOsaY = new Panel();
            Table tblLinePseudo = new Table();
            divOsaY.Controls.Add(tblLinePseudo);
            tblLinePseudo.CssClass = "productionTimeHeader";

            TableHeaderRow hRow = new TableHeaderRow();
            TableHeaderCell th = new TableHeaderCell();
            th.Text = string.Format("<h5>Timer</h5>");

            hRow.Cells.Add(th);
            tblLinePseudo.Rows.Add(hRow);

            for (int pixel = 0; pixel < graph.MakeSpan+15; pixel++)
            {
                TableRow trOsaY = new TableRow();
                TableCell tcOsaY = new TableCell();

                trOsaY.CssClass = "tblOsaY";
                trOsaY.Height = Unit.Parse(10*magicHeightConstant + "px");
                trOsaY.Controls.Add(new TableCell()
                {
                    Text = string.Format("<strong>{0}</strong>", pixel),
                    CssClass = "tdStartTime bigger right"
                });

                if (pixel % 10 == 0)
                {
                    tblLinePseudo.Rows.Add(trOsaY);
                }

            }
            plcLines.Controls.Add(divOsaY);


            foreach (Machine mach in graph.machines)
            {
                Panel divLine = new Panel();
                //divLine.CssClass = "col-md-";

                Table tblLine = new Table();
                divLine.Controls.Add(tblLine);
                tblLine.CssClass = "line";
                
                TableHeaderRow hRowLineName = new TableHeaderRow();
                TableHeaderCell thc = new TableHeaderCell();
                thc.Text = string.Format("<h5>{0}</h5>",mach.Name);

                hRowLineName.Cells.Add(thc);
                tblLine.Rows.Add(hRowLineName);

                string previousSetup = string.Empty;

                // kvuli vykreslovani planu (vysce jednotlivych radku)

                int height = 0;
                for (int pixel = 0; pixel < graph.MakeSpan * magicHeightConstant; pixel++)
                {
                    bool foundOp = false;

                    TableRow trPause = new TableRow();
                    TableCell tcPause = new TableCell();
                    tcPause.Text = string.Format("<small>Pause<small>");
                    tcPause.CssClass = "tdPause";


                    trPause.BorderStyle = BorderStyle.Solid;
                    trPause.BorderColor = System.Drawing.Color.Gray;
                    trPause.BorderWidth = Unit.Parse("1px");

                    trPause.Height = Unit.Parse(height + "px");
                    trPause.Cells.Add(tcPause);
                    

                    for (int i = 0; i<mach.operations.Count;i++)
                    {
                        Operation currOp = mach.operations[i];
                        if (currOp.Est * magicHeightConstant == pixel)
                        {
                            if (trPause.Height.Value > 0)
                            {
                                tblLine.Rows.Add(trPause);
                                height = 0;                            
                            }
                            TableRow tr = new TableRow();
                            tr.Attributes.Add("planID", currOp.ID.ToString());
                            tr.CssClass = "plannedProduct";
                            TableCell tc = new TableCell();

                            
                            Table info = new Table();
                            info.CssClass = "tblPlannedProduct";
                            info.ID = Convert.ToString(string.Format("PlanID-{0}", currOp.PlanID));

                            TableRow trStart = new TableRow();
                            trStart.Controls.Add(new TableCell(){
                               Text =string.Format("<strong>{0}</strong>", currOp.Est),
                               CssClass  = "tdStartTime bigger"
                            });
                            info.Controls.Add(trStart);

                            TableRow trDetails = new TableRow();
                            /*
                            Table tblDetails = new Table();
                            TableRow trName = new TableRow();
                            TableCell tcName = 
                            */
                            trDetails.Controls.Add(new TableCell()
                            {
                                CssClass = "tdDetail",
                                Text = string.Format("<img src='/Images/circle_detail.png'/><h4>{0}<br/><small>{1}</small></h4>",currOp.Name, currOp.Setup)
                            });
                            info.Controls.Add(trDetails);

                            TableRow trEnd = new TableRow();
                            trEnd.Controls.Add(new TableCell()
                            {
                                Text = string.Format("<strong>{0}</strong>", currOp.Eet),
                                CssClass = "tdEndTime bigger"
                            });
                            info.Controls.Add(trEnd);


                            tc.Controls.Add(info);

                            tr.BorderStyle = BorderStyle.Solid;
                            tr.BorderColor = System.Drawing.Color.Gray;
                            tr.BorderWidth = Unit.Parse("1px");

                            int productionTime = Convert.ToInt32(currOp.Cost);
                            tc.Height = Unit.Parse(productionTime * magicHeightConstant + "px");
                            tr.Cells.Add(tc);
                            tblLine.Rows.Add(tr);
                            foundOp = true;

                            break;
                        }
                        if (currOp.Est * magicHeightConstant < pixel && currOp.Eet * magicHeightConstant > pixel)
                        {
                            height = 0;
                            foundOp = true;
                            break;
                        }
                       
                    }
                    if (!foundOp)
                    {
                        height++;
                    }

                }

                plcLines.Controls.Add(divLine);


            }
            

        }

        public Graph OptimizePlan(Graph computedPlan, Graph basicGraph)
        {

            int totalNumberBees = 20;
            int numberInactive = 4;
            int numberActive = 10;
            int numberScout = 6;
           
            int maxNumberVisits = 20;
            int maxNumberCycles = 20;

            //best results:
            //int totalNumberBees = 200;
            //int numberInactive = 20;
            //int numberActive = 150;
            //int numberScout = 30; 

            //int maxNumberVisits = 100;
            //int maxNumberCycles = 3460;
            //int maxNumberVisits = 95;
            //int maxNumberCycles = 10570;
            //int maxNumberVisits = 300; // proportional to # of possible neighbors to given solution
            //int maxNumberCycles = 32450;

            Hive hive = new Hive(totalNumberBees, numberInactive, numberActive, numberScout, maxNumberVisits, maxNumberCycles, computedPlan, basicGraph);
            
            Console.WriteLine("\nInitial random hive");
            //GraphStatic.WriteGraph(hive.bestMemoryMatrix);

            Console.WriteLine(hive);

            bool doProgressBar = true;
            hive.Solve(doProgressBar);

            return hive.bestMemoryMatrix;

            //Console.WriteLine("\nFinal hive");
            //Console.WriteLine(hive);

            //GraphStatic.WriteGraph(hive.bestMemoryMatrix);

        }


        protected void btnOptimize_Click(object sender, EventArgs e)
        {
            Graph basicGraph = (Graph)Session["BasicGraph"];
            Graph computedGraph = (Graph)Session["ComputedGraph"];
            Graph optimizedGraph = OptimizePlan(computedGraph, basicGraph);
            DisplayPlan(optimizedGraph);
        }

        private void UpdatePlanInDB(Graph plan)
        {
            foreach(Operation planedProduct in plan.operations)
            {
                string sqlQuery = @"UPDATE [Plan] SET [Order]=@Order WHERE ID=@ID";

                SqlParameter parProductID = new SqlParameter("ID", planedProduct.ID);
                SqlParameter parOrder = new SqlParameter("Order", planedProduct.OrderInMachine);

                SqlParameter[] pars = new SqlParameter[] { parProductID, parOrder };

                using (Database db = new Database())
                {
                    db.Update(sqlQuery, pars);
                }

            }
          
        }

        [WebMethod]
        public static string GetProductInfo(string ID)
        {
            Plan plan = new Plan(ID);

            string myJsonString = (new JavaScriptSerializer()).Serialize(plan);
            return myJsonString;
        }


        [WebMethod]
        public static string GetProducts()
        {
            string sqlQuery = @"
                SELECT DISTINCT
                    ProductInfo.PartNumber
                FROM
                    ProductInfo
                ORDER BY ProductInfo.PartNumber";

            DataTable dataTable = Utility.GetItemsWithQuery(sqlQuery);

            List<string> products = new List<string>();
            foreach (DataRow product in dataTable.Rows)
            {
                string partNumber = Convert.ToString(product["PartNumber"]);

                products.Add(partNumber);
            }

            string myJsonString = (new JavaScriptSerializer()).Serialize(products);
            return myJsonString;
        }

        [WebMethod]
        public static string AddProductToQueue(string qtyPlanned, string partNumber)
        {
            Dictionary<string, string> p = new Dictionary<string, string>();

            List<ProductInfo> products = new List<ProductInfo>(Utility.GetSameProducts(partNumber));
            foreach (ProductInfo product in products)
            {
                long lastOrder = Utility.OrderOfLastProductInLine(product.LineID);

                string sqlQuery = @"INSERT INTO [Plan] (ProductID
                           ,QtyPlanned
                           ,QtyDone
                           ,StatusID
                           ,CommentPlanner
                           ,CommentProduction
                           ,[Order])
                     VALUES	(@ProductID,@QtyPlanned,@QtyDone,@Status,@CommentPlanner,@CommentProduction,@Order)
                ";
                SqlParameter parProductID = new SqlParameter("ProductID", product.ID);
                SqlParameter parQtyPlanned = new SqlParameter("QtyPlanned", qtyPlanned);
                SqlParameter parQtyDone = new SqlParameter("QtyDone", "0");
                SqlParameter parStatus = new SqlParameter("Status", "1");
                SqlParameter parCommentPlanner = new SqlParameter("CommentPlanner", "comment planner");
                SqlParameter parCommentProduction = new SqlParameter("CommentProduction", "comment production");
                SqlParameter parOrder = new SqlParameter("Order", lastOrder + 1);

                SqlParameter[] pars = new SqlParameter[] { parProductID, parQtyPlanned, parQtyDone, parStatus, parCommentPlanner, parCommentProduction, parOrder };

                using (Database db = new Database())
                {
                    db.Insert(sqlQuery, pars);
                }



            }
            p.Add("test", "test2");
            string myJsonString = (new JavaScriptSerializer()).Serialize(p);
            return myJsonString;
        }

        [WebMethod]
        public static string ChangeOrder(int productID)
        {

            return "t";
        }


    }


}